import os
from pgbouncemgr.config import InvalidConfigValue

class NodeConfig():
    def __init__(self, node_id):
        self.node_id = node_id
        self._pgbouncer_config = None
        self.host = None
        self.port = None

    @property
    def pgbouncer_config(self):
        return self._pgbouncer_config

    @pgbouncer_config.setter
    def pgbouncer_config(self, path):
        if not os.path.exists(path):
            raise InvalidConfigValue(
                "pgbouncer_config path must exist",
                "nodes[%s]" % self.node_id, "pgbouncer_config", path)
        self._pgbouncer_config = path

    def export(self):
        return {
            "pgbouncer_config": self.pgbouncer_config,
            "host": self.host,
            "port": self.port
        }
